<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>KeeperException.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">KeeperException.java</span></div><h1>KeeperException.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.util.ArrayList;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@SuppressWarnings(&quot;serial&quot;)
public abstract class KeeperException extends Exception {
    /**
     * All multi-requests that result in an exception retain the results
     * here so that it is possible to examine the problems in the catch
     * scope.  Non-multi requests will get a null if they try to access
     * these results.
     */
    private List&lt;OpResult&gt; results;

    /**
     * All non-specific keeper exceptions should be constructed via
     * this factory method in order to guarantee consistency in error
     * codes and such.  If you know the error code, then you should
     * construct the special purpose exception directly.  That will
     * allow you to have the most specific possible declarations of
     * what exceptions might actually be thrown.
     *
     * @param code The error code.
     * @param path The ZooKeeper path being operated on.
     * @return The specialized exception, presumably to be thrown by
     *  the caller.
     */
    public static KeeperException create(Code code, String path) {
<span class="fc" id="L51">        KeeperException r = create(code);</span>
<span class="fc" id="L52">        r.path = path;</span>
<span class="fc" id="L53">        return r;</span>
    }

    /**
     * @deprecated deprecated in 3.1.0, use {@link #create(Code, String)}
     * instead
     */
    @Deprecated
    public static KeeperException create(int code, String path) {
<span class="nc" id="L62">        KeeperException r = create(Code.get(code));</span>
<span class="nc" id="L63">        r.path = path;</span>
<span class="nc" id="L64">        return r;</span>
    }

    /**
     * @deprecated deprecated in 3.1.0, use {@link #create(Code)}
     * instead
     */
    @Deprecated
    public static KeeperException create(int code) {
<span class="nc" id="L73">        return create(Code.get(code));</span>
    }

    /**
     * All non-specific keeper exceptions should be constructed via
     * this factory method in order to guarantee consistency in error
     * codes and such.  If you know the error code, then you should
     * construct the special purpose exception directly.  That will
     * allow you to have the most specific possible declarations of
     * what exceptions might actually be thrown.
     *
     * @param code The error code of your new exception.  This will
     * also determine the specific type of the exception that is
     * returned.
     * @return The specialized exception, presumably to be thrown by
     * the caller.
     */
    public static KeeperException create(Code code) {
<span class="pc bpc" id="L91" title="10 of 22 branches missed.">        switch (code) {</span>
            case SYSTEMERROR:
<span class="nc" id="L93">                return new SystemErrorException();</span>
            case RUNTIMEINCONSISTENCY:
<span class="nc" id="L95">                return new RuntimeInconsistencyException();</span>
            case DATAINCONSISTENCY:
<span class="nc" id="L97">                return new DataInconsistencyException();</span>
            case CONNECTIONLOSS:
<span class="fc" id="L99">                return new ConnectionLossException();</span>
            case MARSHALLINGERROR:
<span class="nc" id="L101">                return new MarshallingErrorException();</span>
            case UNIMPLEMENTED:
<span class="nc" id="L103">                return new UnimplementedException();</span>
            case OPERATIONTIMEOUT:
<span class="nc" id="L105">                return new OperationTimeoutException();</span>
            case BADARGUMENTS:
<span class="fc" id="L107">                return new BadArgumentsException();</span>
            case APIERROR:
<span class="nc" id="L109">                return new APIErrorException();</span>
            case NONODE:
<span class="fc" id="L111">                return new NoNodeException();</span>
            case NOAUTH:
<span class="fc" id="L113">                return new NoAuthException();</span>
            case BADVERSION:
<span class="fc" id="L115">                return new BadVersionException();</span>
            case NOCHILDRENFOREPHEMERALS:
<span class="fc" id="L117">                return new NoChildrenForEphemeralsException();</span>
            case NODEEXISTS:
<span class="fc" id="L119">                return new NodeExistsException();</span>
            case INVALIDACL:
<span class="fc" id="L121">                return new InvalidACLException();</span>
            case AUTHFAILED:
<span class="fc" id="L123">                return new AuthFailedException();</span>
            case NOTEMPTY:
<span class="fc" id="L125">                return new NotEmptyException();</span>
            case SESSIONEXPIRED:
<span class="fc" id="L127">                return new SessionExpiredException();</span>
            case INVALIDCALLBACK:
<span class="nc" id="L129">                return new InvalidCallbackException();</span>
            case SESSIONMOVED:
<span class="nc" id="L131">                return new SessionMovedException();</span>
            case NOTREADONLY:
<span class="fc" id="L133">                return new NotReadOnlyException();</span>
            	
            case OK:
            default:
<span class="nc" id="L137">                throw new IllegalArgumentException(&quot;Invalid exception code&quot;);</span>
        }
    }

    /**
     * Set the code for this exception
     * @param code error code
     * @deprecated deprecated in 3.1.0, exceptions should be immutable, this
     * method should not be used
     */
    @Deprecated
    public void setCode(int code) {
<span class="nc" id="L149">        this.code = Code.get(code);</span>
<span class="nc" id="L150">    }</span>

    /** This interface contains the original static final int constants
     * which have now been replaced with an enumeration in Code. Do not
     * reference this class directly, if necessary (legacy code) continue
     * to access the constants through Code.
     * Note: an interface is used here due to the fact that enums cannot
     * reference constants defined within the same enum as said constants
     * are considered initialized _after_ the enum itself. By using an
     * interface as a super type this allows the deprecated constants to
     * be initialized first and referenced when constructing the enums. I
     * didn't want to have constants declared twice. This
     * interface should be private, but it's declared public to enable
     * javadoc to include in the user API spec.
     */
    @Deprecated
    public interface CodeDeprecated {
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#OK} instead
         */
        @Deprecated
        public static final int Ok = 0;

        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#SYSTEMERROR} instead
         */
        @Deprecated
        public static final int SystemError = -1;
        /**
         * @deprecated deprecated in 3.1.0, use
         * {@link Code#RUNTIMEINCONSISTENCY} instead
         */
        @Deprecated
        public static final int RuntimeInconsistency = -2;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#DATAINCONSISTENCY}
         * instead
         */
        @Deprecated
        public static final int DataInconsistency = -3;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#CONNECTIONLOSS}
         * instead
         */
        @Deprecated
        public static final int ConnectionLoss = -4;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#MARSHALLINGERROR}
         * instead
         */
        @Deprecated
        public static final int MarshallingError = -5;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#UNIMPLEMENTED}
         * instead
         */
        @Deprecated
        public static final int Unimplemented = -6;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#OPERATIONTIMEOUT}
         * instead
         */
        @Deprecated
        public static final int OperationTimeout = -7;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#BADARGUMENTS}
         * instead
         */
        @Deprecated
        public static final int BadArguments = -8;

        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#APIERROR} instead
         */
        @Deprecated
        public static final int APIError = -100;

        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#NONODE} instead
         */
        @Deprecated
        public static final int NoNode = -101;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#NOAUTH} instead
         */
        @Deprecated
        public static final int NoAuth = -102;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#BADVERSION} instead
         */
        @Deprecated
        public static final int BadVersion = -103;
        /**
         * @deprecated deprecated in 3.1.0, use
         * {@link Code#NOCHILDRENFOREPHEMERALS}
         * instead
         */
        @Deprecated
        public static final int NoChildrenForEphemerals = -108;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#NODEEXISTS} instead
         */
        @Deprecated
        public static final int NodeExists = -110;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#NOTEMPTY} instead
         */
        @Deprecated
        public static final int NotEmpty = -111;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#SESSIONEXPIRED} instead
         */
        @Deprecated
        public static final int SessionExpired = -112;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#INVALIDCALLBACK}
         * instead
         */
        @Deprecated
        public static final int InvalidCallback = -113;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#INVALIDACL} instead
         */
        @Deprecated
        public static final int InvalidACL = -114;
        /**
         * @deprecated deprecated in 3.1.0, use {@link Code#AUTHFAILED} instead
         */
        @Deprecated
        public static final int AuthFailed = -115;
        /**
         * This value will be used directly in {@link CODE#SESSIONMOVED}
         */
        // public static final int SessionMoved = -118;
    }

    /** Codes which represent the various KeeperException
     * types. This enum replaces the deprecated earlier static final int
     * constants. The old, deprecated, values are in &quot;camel case&quot; while the new
     * enum values are in all CAPS.
     */
<span class="pc" id="L291">    public static enum Code implements CodeDeprecated {</span>
        /** Everything is OK */
<span class="fc" id="L293">        OK (Ok),</span>

        /** System and server-side errors.
         * This is never thrown by the server, it shouldn't be used other than
         * to indicate a range. Specifically error codes greater than this
         * value, but lesser than {@link #APIERROR}, are system errors.
         */
<span class="fc" id="L300">        SYSTEMERROR (SystemError),</span>

        /** A runtime inconsistency was found */
<span class="fc" id="L303">        RUNTIMEINCONSISTENCY (RuntimeInconsistency),</span>
        /** A data inconsistency was found */
<span class="fc" id="L305">        DATAINCONSISTENCY (DataInconsistency),</span>
        /** Connection to the server has been lost */
<span class="fc" id="L307">        CONNECTIONLOSS (ConnectionLoss),</span>
        /** Error while marshalling or unmarshalling data */
<span class="fc" id="L309">        MARSHALLINGERROR (MarshallingError),</span>
        /** Operation is unimplemented */
<span class="fc" id="L311">        UNIMPLEMENTED (Unimplemented),</span>
        /** Operation timeout */
<span class="fc" id="L313">        OPERATIONTIMEOUT (OperationTimeout),</span>
        /** Invalid arguments */
<span class="fc" id="L315">        BADARGUMENTS (BadArguments),</span>
        
        /** API errors.
         * This is never thrown by the server, it shouldn't be used other than
         * to indicate a range. Specifically error codes greater than this
         * value are API errors (while values less than this indicate a
         * {@link #SYSTEMERROR}).
         */
<span class="fc" id="L323">        APIERROR (APIError),</span>

        /** Node does not exist */
<span class="fc" id="L326">        NONODE (NoNode),</span>
        /** Not authenticated */
<span class="fc" id="L328">        NOAUTH (NoAuth),</span>
        /** Version conflict */
<span class="fc" id="L330">        BADVERSION (BadVersion),</span>
        /** Ephemeral nodes may not have children */
<span class="fc" id="L332">        NOCHILDRENFOREPHEMERALS (NoChildrenForEphemerals),</span>
        /** The node already exists */
<span class="fc" id="L334">        NODEEXISTS (NodeExists),</span>
        /** The node has children */
<span class="fc" id="L336">        NOTEMPTY (NotEmpty),</span>
        /** The session has been expired by the server */
<span class="fc" id="L338">        SESSIONEXPIRED (SessionExpired),</span>
        /** Invalid callback specified */
<span class="fc" id="L340">        INVALIDCALLBACK (InvalidCallback),</span>
        /** Invalid ACL specified */
<span class="fc" id="L342">        INVALIDACL (InvalidACL),</span>
        /** Client authentication failed */
<span class="fc" id="L344">        AUTHFAILED (AuthFailed),</span>
        /** Session moved to another server, so operation is ignored */
<span class="fc" id="L346">        SESSIONMOVED (-118),</span>
        /** State-changing request is passed to read-only server */
<span class="fc" id="L348">        NOTREADONLY (-119);</span>

<span class="fc" id="L350">        private static final Map&lt;Integer,Code&gt; lookup</span>
            = new HashMap&lt;Integer,Code&gt;();

        static {
<span class="fc bfc" id="L354" title="All 2 branches covered.">            for(Code c : EnumSet.allOf(Code.class))</span>
<span class="fc" id="L355">                lookup.put(c.code, c);</span>
<span class="fc" id="L356">        }</span>

        private final int code;
<span class="fc" id="L359">        Code(int code) {</span>
<span class="fc" id="L360">            this.code = code;</span>
<span class="fc" id="L361">        }</span>

        /**
         * Get the int value for a particular Code.
         * @return error code as integer
         */
<span class="fc" id="L367">        public int intValue() { return code; }</span>

        /**
         * Get the Code value for a particular integer error code
         * @param code int error code
         * @return Code value corresponding to specified int code, or null
         */
        public static Code get(int code) {
<span class="fc" id="L375">            return lookup.get(code);</span>
        }
    }

    static String getCodeMessage(Code code) {
<span class="pc bpc" id="L380" title="12 of 23 branches missed.">        switch (code) {</span>
            case OK:
<span class="nc" id="L382">                return &quot;ok&quot;;</span>
            case SYSTEMERROR:
<span class="nc" id="L384">                return &quot;SystemError&quot;;</span>
            case RUNTIMEINCONSISTENCY:
<span class="nc" id="L386">                return &quot;RuntimeInconsistency&quot;;</span>
            case DATAINCONSISTENCY:
<span class="nc" id="L388">                return &quot;DataInconsistency&quot;;</span>
            case CONNECTIONLOSS:
<span class="fc" id="L390">                return &quot;ConnectionLoss&quot;;</span>
            case MARSHALLINGERROR:
<span class="nc" id="L392">                return &quot;MarshallingError&quot;;</span>
            case UNIMPLEMENTED:
<span class="nc" id="L394">                return &quot;Unimplemented&quot;;</span>
            case OPERATIONTIMEOUT:
<span class="nc" id="L396">                return &quot;OperationTimeout&quot;;</span>
            case BADARGUMENTS:
<span class="fc" id="L398">                return &quot;BadArguments&quot;;</span>
            case APIERROR:
<span class="nc" id="L400">                return &quot;APIError&quot;;</span>
            case NONODE:
<span class="fc" id="L402">                return &quot;NoNode&quot;;</span>
            case NOAUTH:
<span class="fc" id="L404">                return &quot;NoAuth&quot;;</span>
            case BADVERSION:
<span class="fc" id="L406">                return &quot;BadVersion&quot;;</span>
            case NOCHILDRENFOREPHEMERALS:
<span class="fc" id="L408">                return &quot;NoChildrenForEphemerals&quot;;</span>
            case NODEEXISTS:
<span class="fc" id="L410">                return &quot;NodeExists&quot;;</span>
            case INVALIDACL:
<span class="fc" id="L412">                return &quot;InvalidACL&quot;;</span>
            case AUTHFAILED:
<span class="fc" id="L414">                return &quot;AuthFailed&quot;;</span>
            case NOTEMPTY:
<span class="fc" id="L416">                return &quot;Directory not empty&quot;;</span>
            case SESSIONEXPIRED:
<span class="fc" id="L418">                return &quot;Session expired&quot;;</span>
            case INVALIDCALLBACK:
<span class="nc" id="L420">                return &quot;Invalid callback&quot;;</span>
            case SESSIONMOVED:
<span class="nc" id="L422">                return &quot;Session moved&quot;;</span>
            case NOTREADONLY:
<span class="nc" id="L424">                return &quot;Not a read-only call&quot;;</span>
            default:
<span class="nc" id="L426">                return &quot;Unknown error &quot; + code;</span>
        }
    }

    private Code code;

    private String path;

<span class="fc" id="L434">    public KeeperException(Code code) {</span>
<span class="fc" id="L435">        this.code = code;</span>
<span class="fc" id="L436">    }</span>

<span class="fc" id="L438">    KeeperException(Code code, String path) {</span>
<span class="fc" id="L439">        this.code = code;</span>
<span class="fc" id="L440">        this.path = path;</span>
<span class="fc" id="L441">    }</span>

    /**
     * Read the error code for this exception
     * @return the error code for this exception
     * @deprecated deprecated in 3.1.0, use {@link #code()} instead
     */
    @Deprecated
    public int getCode() {
<span class="nc" id="L450">        return code.code;</span>
    }

    /**
     * Read the error Code for this exception
     * @return the error Code for this exception
     */
    public Code code() {
<span class="fc" id="L458">        return code;</span>
    }

    /**
     * Read the path for this exception
     * @return the path associated with this error, null if none
     */
    public String getPath() {
<span class="fc" id="L466">        return path;</span>
    }

    @Override
    public String getMessage() {
<span class="fc bfc" id="L471" title="All 2 branches covered.">        if (path == null) {</span>
<span class="fc" id="L472">            return &quot;KeeperErrorCode = &quot; + getCodeMessage(code);</span>
        }
<span class="fc" id="L474">        return &quot;KeeperErrorCode = &quot; + getCodeMessage(code) + &quot; for &quot; + path;</span>
    }

    void setMultiResults(List&lt;OpResult&gt; results) {
<span class="fc" id="L478">        this.results = results;</span>
<span class="fc" id="L479">    }</span>

    /**
     * If this exception was thrown by a multi-request then the (partial) results
     * and error codes can be retrieved using this getter.
     * @return A copy of the list of results from the operations in the multi-request.
     * 
     * @since 3.4.0
     *
     */
    public List&lt;OpResult&gt; getResults() {
<span class="pc bpc" id="L490" title="1 of 2 branches missed.">        return results != null ? new ArrayList&lt;OpResult&gt;(results) : null;</span>
    }

    /**
     *  @see Code#APIERROR
     */
    public static class APIErrorException extends KeeperException {
        public APIErrorException() {
<span class="nc" id="L498">            super(Code.APIERROR);</span>
<span class="nc" id="L499">        }</span>
    }

    /**
     *  @see Code#AUTHFAILED
     */
    public static class AuthFailedException extends KeeperException {
        public AuthFailedException() {
<span class="fc" id="L507">            super(Code.AUTHFAILED);</span>
<span class="fc" id="L508">        }</span>
    }

    /**
     *  @see Code#BADARGUMENTS
     */
    public static class BadArgumentsException extends KeeperException {
        public BadArgumentsException() {
<span class="fc" id="L516">            super(Code.BADARGUMENTS);</span>
<span class="fc" id="L517">        }</span>
        public BadArgumentsException(String path) {
<span class="fc" id="L519">            super(Code.BADARGUMENTS, path);</span>
<span class="fc" id="L520">        }</span>
    }

    /**
     * @see Code#BADVERSION
     */
    public static class BadVersionException extends KeeperException {
        public BadVersionException() {
<span class="fc" id="L528">            super(Code.BADVERSION);</span>
<span class="fc" id="L529">        }</span>
        public BadVersionException(String path) {
<span class="fc" id="L531">            super(Code.BADVERSION, path);</span>
<span class="fc" id="L532">        }</span>
    }

    /**
     * @see Code#CONNECTIONLOSS
     */
    public static class ConnectionLossException extends KeeperException {
        public ConnectionLossException() {
<span class="fc" id="L540">            super(Code.CONNECTIONLOSS);</span>
<span class="fc" id="L541">        }</span>
    }

    /**
     * @see Code#DATAINCONSISTENCY
     */
    public static class DataInconsistencyException extends KeeperException {
        public DataInconsistencyException() {
<span class="nc" id="L549">            super(Code.DATAINCONSISTENCY);</span>
<span class="nc" id="L550">        }</span>
    }

    /**
     * @see Code#INVALIDACL
     */
    public static class InvalidACLException extends KeeperException {
        public InvalidACLException() {
<span class="fc" id="L558">            super(Code.INVALIDACL);</span>
<span class="fc" id="L559">        }</span>
        public InvalidACLException(String path) {
<span class="fc" id="L561">            super(Code.INVALIDACL, path);</span>
<span class="fc" id="L562">        }</span>
    }

    /**
     * @see Code#INVALIDCALLBACK
     */
    public static class InvalidCallbackException extends KeeperException {
        public InvalidCallbackException() {
<span class="nc" id="L570">            super(Code.INVALIDCALLBACK);</span>
<span class="nc" id="L571">        }</span>
    }

    /**
     * @see Code#MARSHALLINGERROR
     */
    public static class MarshallingErrorException extends KeeperException {
        public MarshallingErrorException() {
<span class="nc" id="L579">            super(Code.MARSHALLINGERROR);</span>
<span class="nc" id="L580">        }</span>
    }

    /**
     * @see Code#NOAUTH
     */
    public static class NoAuthException extends KeeperException {
        public NoAuthException() {
<span class="fc" id="L588">            super(Code.NOAUTH);</span>
<span class="fc" id="L589">        }</span>
    }

    /**
     * @see Code#NOCHILDRENFOREPHEMERALS
     */
    public static class NoChildrenForEphemeralsException extends KeeperException {
        public NoChildrenForEphemeralsException() {
<span class="fc" id="L597">            super(Code.NOCHILDRENFOREPHEMERALS);</span>
<span class="fc" id="L598">        }</span>
        public NoChildrenForEphemeralsException(String path) {
<span class="fc" id="L600">            super(Code.NOCHILDRENFOREPHEMERALS, path);</span>
<span class="fc" id="L601">        }</span>
    }

    /**
     * @see Code#NODEEXISTS
     */
    public static class NodeExistsException extends KeeperException {
        public NodeExistsException() {
<span class="fc" id="L609">            super(Code.NODEEXISTS);</span>
<span class="fc" id="L610">        }</span>
        public NodeExistsException(String path) {
<span class="fc" id="L612">            super(Code.NODEEXISTS, path);</span>
<span class="fc" id="L613">        }</span>
    }

    /**
     * @see Code#NONODE
     */
    public static class NoNodeException extends KeeperException {
        public NoNodeException() {
<span class="fc" id="L621">            super(Code.NONODE);</span>
<span class="fc" id="L622">        }</span>
        public NoNodeException(String path) {
<span class="fc" id="L624">            super(Code.NONODE, path);</span>
<span class="fc" id="L625">        }</span>
    }

    /**
     * @see Code#NOTEMPTY
     */
    public static class NotEmptyException extends KeeperException {
        public NotEmptyException() {
<span class="fc" id="L633">            super(Code.NOTEMPTY);</span>
<span class="fc" id="L634">        }</span>
        public NotEmptyException(String path) {
<span class="fc" id="L636">            super(Code.NOTEMPTY, path);</span>
<span class="fc" id="L637">        }</span>
    }

    /**
     * @see Code#OPERATIONTIMEOUT
     */
    public static class OperationTimeoutException extends KeeperException {
        public OperationTimeoutException() {
<span class="nc" id="L645">            super(Code.OPERATIONTIMEOUT);</span>
<span class="nc" id="L646">        }</span>
    }

    /**
     * @see Code#RUNTIMEINCONSISTENCY
     */
    public static class RuntimeInconsistencyException extends KeeperException {
        public RuntimeInconsistencyException() {
<span class="nc" id="L654">            super(Code.RUNTIMEINCONSISTENCY);</span>
<span class="nc" id="L655">        }</span>
    }

    /**
     * @see Code#SESSIONEXPIRED
     */
    public static class SessionExpiredException extends KeeperException {
        public SessionExpiredException() {
<span class="fc" id="L663">            super(Code.SESSIONEXPIRED);</span>
<span class="fc" id="L664">        }</span>
    }
    
    /**
     * @see Code#SESSIONMOVED
     */
    public static class SessionMovedException extends KeeperException {
        public SessionMovedException() {
<span class="nc" id="L672">            super(Code.SESSIONMOVED);</span>
<span class="nc" id="L673">        }</span>
    }

    /**
     * @see Code#NOTREADONLY
     */
    public static class NotReadOnlyException extends KeeperException {
        public NotReadOnlyException() {
<span class="fc" id="L681">            super(Code.NOTREADONLY);</span>
<span class="fc" id="L682">        }</span>
    }

    /**
     * @see Code#SYSTEMERROR
     */
    public static class SystemErrorException extends KeeperException {
        public SystemErrorException() {
<span class="nc" id="L690">            super(Code.SYSTEMERROR);</span>
<span class="nc" id="L691">        }</span>
    }

    /**
     * @see Code#UNIMPLEMENTED
     */
    public static class UnimplementedException extends KeeperException {
        public UnimplementedException() {
<span class="fc" id="L699">            super(Code.UNIMPLEMENTED);</span>
<span class="fc" id="L700">        }</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>